#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "mapa.h"
#include "video.h"
#include "BFont.h"
#include "sdlfunc.h"

struct TTileMap NovoMapa;
SDL_Surface *SrcTile;
SDL_Surface *BtnSobe;
SDL_Surface *BtnDesce;
SDL_Rect SrcRect;
SDL_Rect ScreenRect;
SDL_Rect RBtnDesce;
SDL_Rect RBtnSobe;

void mostra_param()
{
   printf("<novo_mapa> <tiles> <tile_h>  <tile_w> <total_tiles> <colunas> <linhas>\n");
}

void DesenhaSrcTile(void)
{
   SDL_Rect DstRect;
   int Count;
   int x= 0;
   int y = 0;
   int w,h;;
   
   w = NovoMapa.TileW * 5;
   h = NovoMapa.TileH * NovoMapa.NumTiles / 5;
   
   SrcTile = SDL_CreateRGBSurface(SDL_SWSURFACE,w,h,16,
				  screen->format->Rmask,screen->format->Gmask,screen->format->Gmask,screen->format->Amask);
   
   if (SrcTile == NULL)
     {
	printf("Nao foi possivel alocar espaco na memoria\n");
	exit(0);
     }
   
   for(Count=0;Count<NovoMapa.NumTiles;Count++)
     {
	if (x*NovoMapa.TileW >= SrcTile->w)
	  {
	     y++;
	     x = 0;
	  }
	DstRect.x = x * NovoMapa.TileW;
	DstRect.y = y * NovoMapa.TileH;
	DstRect.w = x * NovoMapa.TileW + NovoMapa.TileW;
	DstRect.h = y * NovoMapa.TileH + NovoMapa.TileH;
	x++;
	SDL_BlitSurface(NovoMapa.TileSrc[Count],NULL,SrcTile,&DstRect);
     }
   ScreenRect.x = ((screen->w) - (NovoMapa.TileW * 5)) - 16;
   ScreenRect.y = 0;
   ScreenRect.w = screen->w;
   ScreenRect.h = screen->h;
   
   SrcRect.x = 0;
   SrcRect.y = 0;
   SrcRect.h = screen->h;
   SrcRect.w = SrcTile->w;
     
   SDL_UpdateRect(SrcTile,0,0,0,0);
				  
   /*cria caixa
  h_line(screen,(screen->w)-(NovoMapa.TileW * 3),(screen->w -2),2,0xffff);
  h_line(screen,(screen->w)-(NovoMapa.TileW * 3),(screen->w -2),(screen->h -2),0xffff);
  v_line(screen,2,(screen->h -2),(screen->h)-(NovoMapa.TileW * 3),0xffff);
   v_line(screen,2,(screen->h -2),(screen->h -2),0xffff);*/
}

void IniciaMapa(void)
  {
     int x,y;
     int w = NovoMapa.TileX * NovoMapa.TileW;
     int h = NovoMapa.TileY * NovoMapa.TileH;
     SDL_Rect TmpDstRect;
     
     NovoMapa.Tela = SDL_CreateRGBSurface(SDL_SWSURFACE,w,h,16,
					  screen->format->Rmask,screen->format->Gmask,screen->format->Bmask,screen->format->Amask);
     
    // printf("W %d H %d",(int)NovoMapa.Tela->w,(int)NovoMapa.Tela->h);
     if (NovoMapa.Tela == NULL)
       {
	  printf("Mapa Nulo :-(\n");
	  SDL_Quit();
       }
     
     NovoMapa.DstRect.x = 2;
     NovoMapa.DstRect.y = 20;
     NovoMapa.DstRect.w = 500;
     NovoMapa.DstRect.h = 460;
     
     NovoMapa.SrcRect.x = 0;
     NovoMapa.SrcRect.y = 0;
     NovoMapa.SrcRect.w = 499;
     NovoMapa.SrcRect.h = 400;
     
    for (y=0;y<NovoMapa.TileY;y++)
       for (x=0;x<NovoMapa.TileX;x++)
	 {
	    NovoMapa.MapaSrc[y][x] = 150;
	    TmpDstRect.x = x * NovoMapa.TileW;
	    TmpDstRect.y = y * NovoMapa.TileH;
	    TmpDstRect.w = (x * NovoMapa.TileW) +NovoMapa.TileW;
	    TmpDstRect.h = (y * NovoMapa.TileH) +NovoMapa.TileH;
	    SDL_BlitSurface(NovoMapa.TileSrc[150],NULL,NovoMapa.Tela,&TmpDstRect);
	 }
     //SDL_FillRect(screen,&NovoMapa.Tela->clip_rect,0xffff);
     SDL_UpdateRect(NovoMapa.Tela,0,0,0,0);
	    
  }

void DesenhaMapa(void)
  {
     int x = NovoMapa.DstRect.x -1;
     int y = NovoMapa.DstRect.y -1;
     int h = NovoMapa.DstRect.h +1;
     int w = NovoMapa.DstRect.w +1;
     
     h_line(screen,x,w,y,0xffff);
     h_line(screen,x,w,h,0xffff);
     v_line(screen,y,h,x,0xffff);
     v_line(screen,y,h,w,0xffff);
     
     SDL_BlitSurface(NovoMapa.Tela,&NovoMapa.SrcRect,screen,&NovoMapa.DstRect);
     
  }

void SrcTileScrollUp()
{
   if (!(SrcRect.y -5 <= 0))
     {
	SrcRect.y -= 5;
     }
}

void SrcTileScrollDown()
{
   if (!(SrcRect.y +screen->h +5 >= SrcTile->h))
     {
   SrcRect.y += 5;
     }
   
   
}

   //parametros <novo_mapa> <tiles> <tile_h> <tile_w> <Total_Tiles>
int main(int argc,char *argv[])
{
   FILE ArqMapa;
   BFont_Info *Font1=NULL;
   char *path;
   char *pathtile;
   int tile_w;
   int tile_h;
   int NumTile;
   int colunas;
   int linhas;
   int done = 0;
   //vamos carregar
   
   //verifica se digitou o nome do mapa
   if (argc < 1)
     {
	mostra_param();
	exit(0);
     }
   
   //verifica se digitou o arquivo que contem os tiles
   if (argc < 2)
     {
	mostra_param();
	exit(0);
     }
   
   //verifica se digitou o a altura de cada tile(h)
   if (argc < 3)
     {
	mostra_param();
	exit(0);
     }
   
   //verifica se digitou a largura de cada tile(w)
   if (argc < 4)
     {
	mostra_param();
	exit(0);
     }
   //numero de tiles que comtem o arquivo
   if (argc < 5)
     {
	mostra_param();
	exit(0);
     }
   //colunas do mapa (X)
   if (argc < 6)
     {
	mostra_param();
	  exit(0);
     }
   //linhas do mapa (Y)
   if (argc < 7)
     {
	mostra_param();
	exit(0);
     }
   
   tile_h = atoi(argv[3]);
   tile_w = atoi(argv[4]);
   NumTile = atoi(argv[5]);
   colunas = atoi(argv[6]);
   linhas = atoi(argv[7]);
   NovoMapa.TileX = colunas;
   NovoMapa.TileY = linhas;
   if (SDL_Init(SDL_INIT_VIDEO) < 0)
     {
	printf("Nao foi possivel carregar o modo grafico.\n");
	exit(0);
     }
   
   screen =  SDL_SetVideoMode(640,480,16,SDL_SWSURFACE|SDL_DOUBLEBUF);
   if (screen == NULL)
     {
	printf ("erro ao inicar o modo grafico %s\n",SDL_GetError());
	exit(0);
     }
   
   Font1 = BFont_LoadFont("font03.png");
   if (Font1 == NULL)
    {
	 printf ("Erro nao foi possivel carregar fontes\n");
	SDL_Quit();
   }
   
   BtnDesce = IMG_Load("btndece.png");
   if (BtnDesce == NULL)
     {
	printf("Nao foi Possivel carreggar: btndece.png\n");
	SDL_Quit();
     }
   
   BtnSobe = IMG_Load("btnsobe.png");
   if (BtnSobe == NULL)
     {
	printf("Nao foi Possivel carregar: btnsobe.png\n");
	SDL_Quit();
     }
   
   BFont_SetCurrentFont(Font1);
   printf("Criando Mapa\n");
   NovoMapa = CriaTileMap("Fatalm.BMP",tile_h,tile_w,NumTile,linhas,colunas);
   DesenhaSrcTile();
   SDL_BlitSurface(SrcTile,&SrcRect,screen,&ScreenRect);
   IniciaMapa();
   /*ScreenRect.x = (screen->w - NovoMapa.TileW * 5);
   ScreenRect.y = 0;
   ScreenRect.w = screen->w -16;
   ScreenRect.h = screen->h;*/
   
   RBtnDesce.x = screen->w -16;
   RBtnDesce.y = screen->h -16;
   RBtnDesce.h = screen->h;
   RBtnDesce.w = screen->w;
   
   RBtnSobe.x = screen->w -16;
   RBtnSobe.y = 0;
   RBtnSobe.h = 16;
   RBtnSobe.w = 16;
   
   SDL_BlitSurface(BtnSobe,NULL,screen,&RBtnSobe);
   SDL_BlitSurface(BtnDesce,NULL,screen,&RBtnDesce);
   SDL_ShowCursor(SDL_ENABLE);
   SDL_UpdateRect(screen,0,0,0,0);
   while (done == 0)
     {
	SDL_PollEvent(&evento);
	  if (evento.key.keysym.sym == SDLK_ESCAPE)
	    done = 1;
	
	DesenhaMapa();
	if ((evento.button.button == SDL_BUTTON_LEFT) && (evento.button.state == SDL_PRESSED))
	  {
	  if ((evento.button.x > RBtnSobe.x) && (evento.button.y < RBtnSobe.h))
	       {
		 // printf("scroll\n");
		  SrcTileScrollUp();
		  SDL_FillRect(screen,&ScreenRect,0x0000);
		  SDL_BlitSurface(SrcTile,&SrcRect,screen,&ScreenRect);
		  SDL_UpdateRect(screen,0,0,0,0);
	       }
	  
	  if ((evento.button.x > RBtnDesce.x) && (evento.button.y > RBtnDesce.y))
	       {
		  printf("scroll1\n");
		  SrcTileScrollDown();
		  SDL_FillRect(screen,&ScreenRect,0x0000);
		  SDL_BlitSurface(SrcTile,&SrcRect,screen,&ScreenRect);
		  SDL_UpdateRect(screen,0,0,0,0);
	       }
	     
	  }
	
	if ((evento.button.button == SDL_BUTTON_RIGHT) && (evento.button.state == SDL_PRESSED))
	  {
	  
	  }
	
	SDL_Flip(screen);
	SDL_Delay(20);
     }
   
   SalvaTileMap(NovoMapa,"Teste.map");
   SDL_Quit();
   return 0;
}
