
/***********************************************************/
/*                                                         */
/*   BFONT 1.0.4-1 Test example by Diego Billi             */
/*                                                         */
/***********************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "SDL.h"
#include "SDL_image.h"


/* Use BFont old names style!!!! */

#define  BFONT_KEEP_COMPATIBILITY
#include "BFont.h"

SDL_Surface *screen;

int main(int argc, char *argv[])
{
    BFont_Info *Font1=NULL;
	BFont_Info *Font2=NULL;

    BFont_Info *Font3=NULL;

    int h1,h2;

    if (argc < 3) {
        printf("USAGE: Test <font1> <font2>\n");
        exit(1);
    }

    if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
	    fprintf(stderr,"Couldn't initialize SDL: %s\n", SDL_GetError());
        exit(1);
	}
    atexit(SDL_Quit);
	screen = SDL_SetVideoMode(640, 480, 0, 0);
	if ( screen == NULL ) {
		fprintf(stderr, "Couldn't set %dx%dx%d video mode: %s\n",640, 480, 16, SDL_GetError());
		exit(1);
    }


    /* Load fonts files */

    puts("loading fonts...");


	/* New feature added with 1.0.4 version */
	// Font1 = LoadFontFromSurface( (SDL_Surface *) IMG_Load(argv[1]) );

	Font1 = LoadFont(argv[1]);
	if (Font1 == NULL) {
		fprintf(stderr, "Couldnt load %s\n",argv[1]);
		exit(1);
    }

	Font2 = LoadFont(argv[2]);
	if (Font2 == NULL) {
		fprintf(stderr, "Couldnt load %s\n",argv[2]);
		exit(1);
	}


    Font3 = SetFontColor(Font1,250,0,0);

    /* Get fonts height */
    h1 = FontHeight(Font1);
    h2 = FontHeight(Font2);

    /* Set the default font */
    SetCurrentFont(Font3);

    /* Write different strings with the defaul font */

	PutString            (screen,  0, 0, "This string is at (0,0).");
    LeftPutString        (screen,  1*h1, "Left aligned text!");
    CenteredPutString    (screen,  2*h1, "Centered text!");
    RightPutString       (screen,  3*h1, "Right aligned text!");
    JustifiedPutString   (screen,  4*h1, "Fine justified text example!");

    /* Write different strings with a specific font and different arguments :-)*/
    PrintStringFont          (screen, Font2,0, 4*h2+100, "This string is at (%d,%d)", 0, 4*h2+100);
    LeftPrintStringFont      (screen, Font2, 5*h2+100, "Left aligned text! %d",10);
    CenteredPrintStringFont  (screen, Font2, 6*h2+100, "Centered text! %3.2f",3.14);
    RightPrintStringFont     (screen, Font2, 7*h2+100, "Right aligned text! %d %3.3f",10,666.999);
    JustifiedPrintStringFont (screen, Font2, 8*h2+100, "Fine justified text example! %s","hello!");


    SDL_UpdateRect(screen, 0, 0, 0, 0);

    SDL_Delay(3000);

    FreeFont(Font1);
    FreeFont(Font2);
    FreeFont(Font3);

    SDL_Quit();

    return 0;
}



